# Use the default kernel version if the Makefile doesn't override it

LINUX_RELEASE?=1

LINUX_VERSION-3.10 = .58
LINUX_VERSION-3.14 = .26
LINUX_VERSION-3.18 =

LINUX_KERNEL_MD5SUM-3.10.58 = bca8cde0dddf27d980fe1d393ea743f7
LINUX_KERNEL_MD5SUM-3.14.26 = 69b27733f335c557946edd58554debb7
LINUX_KERNEL_MD5SUM-3.18    = 9e854df51ca3fef8bfe566dbd7b89241

ifdef KERNEL_PATCHVER
  LINUX_VERSION:=$(KERNEL_PATCHVER)$(strip $(LINUX_VERSION-$(KERNEL_PATCHVER)))
endif

split_version=$(subst ., ,$(1))
merge_version=$(subst $(space),.,$(1))
KERNEL_BASE=$(firstword $(subst -, ,$(LINUX_VERSION)))
KERNEL=$(call merge_version,$(wordlist 1,2,$(call split_version,$(KERNEL_BASE))))
KERNEL_PATCHVER ?= $(KERNEL)

# disable the md5sum check for unknown kernel versions
LINUX_KERNEL_MD5SUM:=$(LINUX_KERNEL_MD5SUM-$(strip $(LINUX_VERSION)))
LINUX_KERNEL_MD5SUM?=x
